/*
 * Created on May 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.tanneryd.soapclipse;

import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

/**
 * @author manst
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class SoapClipseTools
{
	public static Button addCheckBoxItems(
		Composite container,
		int horizontalSpan,
		String labelText)
	{
		Button checkBox = new Button(container, SWT.CHECK);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = horizontalSpan;
		checkBox.setText(labelText);
		checkBox.setLayoutData(gd);
		
		return checkBox;
	}

	public static Combo addComboBoxItems(
	Composite container,
	int horizontalSpan,	
	String labelText,
	String[] choices)
	{
		Label label = new Label(container, SWT.NULL);
		label.setText( labelText );

		Combo comboBox = new Combo(container, SWT.READ_ONLY);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = horizontalSpan;
		gd.horizontalAlignment = GridData.HORIZONTAL_ALIGN_BEGINNING;
		comboBox.setItems( choices );
		comboBox.setLayoutData(gd);
		comboBox.select(0);
		
		return comboBox;
	}
	
	/**
	 * 
	 * @param container
	 * @param horizontalSpan
	 * @param labelText
	 * @param toolTip
	 * @return
	 */
	public static Text addTextInputItems(
		Composite container,
		int horizontalSpan,
		String labelText,
		String toolTip)
	{
		Label label = new Label(container, SWT.NULL);
		label.setText(labelText);
		Text textBox = new Text(container, SWT.BORDER | SWT.SINGLE);
		textBox.setToolTipText(toolTip);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = horizontalSpan;
		textBox.setLayoutData(gd);
		
		return textBox;
	}

	/**
	 * Load the value, or the default value into a text control.
	 * 
	 * @param textBox
	 * @param value
	 * @param defaultValue
	 */
	public static void loadTextSetting( Text textBox, String value, String defaultValue )
	{
		if ( value != null)
			textBox.setText( value );
		else if ( defaultValue != null )
			textBox.setText( defaultValue );
	}
	
	public static void loadTextSetting( Text textBox, String value )
	{
		loadTextSetting( textBox, value, null );
	}


	/**
	 * Currently this method only supports paths pointing at 
	 * project roots or folders. It will not resolve file
	 * locations successfully.
	 * 
	 * @param workspaceRelativeFolderPath
	 * @return Complete file system path
	 */
	public static String toFileSystemPath(String workspaceRelativeFolderPath)
	{
		// But ugly solution, will have to do for now...
		Path savedPath = new Path(workspaceRelativeFolderPath);
		IProject project = null;
		String fileSystemPath = null;
		
		// Check if our path points at a project root
		try
		{
			project =
				ResourcesPlugin.getWorkspace().getRoot().getProject(
					workspaceRelativeFolderPath);
		}
		catch (java.lang.IllegalArgumentException ex)
		{
			project = null;
		}

		// If we're not a project root we're a folder
		if (project == null)
		{
			IFolder f =
				ResourcesPlugin.getWorkspace().getRoot().getFolder(savedPath);
			return f.getLocation().toOSString();
		}
		else
			return project.getLocation().toOSString();
	}
}
