package com.tanneryd.soapclipse.popup.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageDeclaration;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import com.tanneryd.soapclipse.java2wsdl.Java2WSDLWizard;

public class Java2WSDLAction implements IObjectActionDelegate
{
	private IFile selectedFile;
	private IPackageDeclaration selectedPackage;
	private IJavaProject javaProject;
	private ISelection selection;
	private Shell shell;

	/*
	 * 
	 */
	private void runEmitter() throws Exception
	{
		Java2WSDLWizard wizard = new Java2WSDLWizard( selectedFile, selectedPackage, javaProject );
			
		WizardDialog dialog = new WizardDialog(shell, wizard);
		dialog.open();
	}

	/**
	 * Constructor for Action1.
	 */
	public Java2WSDLAction()
	{
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart)
	{
		shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action)
	{
		Shell shell = new Shell();

		try
		{
			runEmitter();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection)
	{
		try
		{
			this.selectedFile = null;
			this.selection = selection;
			if (selection instanceof IStructuredSelection)
			{
				IStructuredSelection structuredSelection =
					(IStructuredSelection) selection;
				if (structuredSelection.size() == 1)
				{
					Object selectedResource =
						structuredSelection.getFirstElement();
					if (selectedResource instanceof ICompilationUnit)
					{
						ICompilationUnit compilationUnit =
							(ICompilationUnit) selectedResource;
						selectedFile =
							(IFile) compilationUnit.getCorrespondingResource();
						selectedPackage = (IPackageDeclaration) compilationUnit.getPackageDeclarations()[0];
						javaProject = compilationUnit.getJavaProject();
					}
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

}
