/*
 * Copyright 2004 Mns Tnneryd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * 	http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */ 
package com.tanneryd.soapclipse.popup.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import com.tanneryd.soapclipse.wsdl2java.WSDL2JavaWizard;

public class WSDL2JavaAction implements IObjectActionDelegate
{
	private IFile selectedFile;
	private ISelection selection;
	private Shell shell;

	/**
	 * Constructor for Action1.
	 */
	public WSDL2JavaAction()
	{
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart)
	{
		shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action)
	{
		try
		{
//			String outputDirectory =
//				selectedFile.getLocation().removeLastSegments(1).toOSString();
//			String wsdlUri = selectedFile.getLocation().toFile().toURI().toString();

			WSDL2JavaWizard wizard = new WSDL2JavaWizard( selectedFile );
			
			
			WizardDialog dialog = new WizardDialog(shell, wizard);
			dialog.open();

//
//			generateJavaFromWSDL(wsdlUrl, outputDirectory);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection)
	{
		this.selectedFile = null;
		this.selection = selection;
		if (selection instanceof IStructuredSelection)
		{
			IStructuredSelection structuredSelection =
				(IStructuredSelection) selection;
			if (structuredSelection.size() == 1)
			{
				Object selectedResource = structuredSelection.getFirstElement();
				if (selectedResource instanceof IFile)
					selectedFile = (IFile) selectedResource;
			}
		}
	}
}
